/*****************************************************

Metalab Display Driver
by flo@isp.at    17.7.2006



based on code from wizards23@gmail.com

released under the GPL


this makes use of
 - TLC 5940  led driver
 - microchip 18f452 


have fun and dont be too scared =)
******************************************************/


#include "18f458.h"
//#include "16f877.h"

#device ADC=10
#include <STDLIB.H>
#include <math.h>
#fuses hs,nowdt,put,noprotect
#use delay(clock=20000000)	//20MHz, for delay()


// Names of the Input Pins of the LED Driver according to the datasheet
#define VPRG  PIN_D1  //27
#define SIN_PIN   PIN_D2  //26 in the DIP package
#define SCLK  PIN_D3  //25
#define XLAT  PIN_D4  //24
#define BLANK PIN_D5  //23
#define DCPRG PIN_D6  //19
#define GSCLK PIN_D7  //18

#define CHANNELS 64 // set this to a multiple of 16 if you cascade more than one TLC5940

#include "TLC5940.h"

#use rs232(baud=19200, xmit=PIN_C6, rcv=PIN_C7, Errors)



// wicked constans for the logo in the lower right

#define PHONE_GREEN_0 0
#define PHONE_GREEN_1 1
#define PHONE_GREEN_2 2
#define PHONE_GREEN_3 3

#define ATOM_RED_0 4
#define ATOM_RED_1 5
#define ATOM_RED_2 6
#define ATOM_RED_3 7
#define ATOM_RED_4 8
#define ATOM_RED_5 9

#define PHONE_BLUE_0 10
#define PHONE_BLUE_1 11
#define PHONE_BLUE_2 12





#define RED 16
#define GREEN 32
#define BLUE 48






int atom_state, atom_dir, atom_delay;
int phone_state;
long phone_count;

//global  if set a function is currently running..
int function_active;
long steps, stepper;





// setoff for the pins and colors.. 16 channels / color
// starting from  the lower left corner 8 channels then from the upper right to the upper left corner


/*
__________________
|15 14 13 12 11 10 9  |
|                               |                                    
|   M E T A L A B       |
|                               |                                  
|0_1_2_3_4_5_6_7_8_|


groups are
0 and 15
1 and 14
2 and 13 .... 


opposite rgb units are a "group"
therefor we got 8 groups
*/


int groups[8];





// guess what this does ;)

void init_metalab() {
	// magic atom vars.. nevermind :)
   atom_state = 0;
   atom_dir = 1;
   atom_delay = 120;
   phone_state = 0;
   phone_count = 0;

  // if a function (mode) runs this is set to 1
   function_active=0;
   
   // stuff will run for a maximum of 1000 steps
   steps=1000;
   
   // incremented in each step
   stepper=0;
   
   
   //  for the funky rainbow mode
   // ugly  to put this stuff outside the faunction for the rainbow mode but i had to do it :/
 groups[0]=1;
 groups[1]=1;
 groups[2]=2;
 groups[3]=4;
 groups[4]=4;
 groups[5]=8;
 groups[6]=16;
 groups[7]=32;
   
   
   
}






/*  

 the following functions are used from different functions
 this have to be set BEFORE call in functions defined  deeper down the code.
 ugly C  :/


*/


// turn on a given channel
// the whereami stuff is described later on in the code
void channel_on(int *whereami, int channel)
{

               all_off();
               all_on(channel,63);

               //run 100 steps
               if(*whereami>100)
               {
                function_active=0;
               }
               (*whereami)++;
}








// turn off all color channels
// this will not affect the phone/atom  - logo
void all_off() {
   int i;
   for (i = 0; i <48; i++) {
      dcs[16 + i] =  0;
   }

}




// turn on all leds from the given coloroffset
void all_on(int color_offset, long brightness) {
   int i;
   for (i = 0; i <16; i++) {
      dcs[color_offset + i] =  brightness;
   }

}





/*  END OF REUSEABLE FUNCTIONS */












/* START OF BLINKING FUNCTIONS THAT DO SOME MAGIC ON THE DISPLAY */


// wicked function from philipp
// makes the atom fade to red and out again
void step_atom() {
   if (atom_delay > 0) {
      atom_delay--;
   }
   else {
      atom_state += atom_dir;

      if (atom_state == 63 || atom_state == 0) {
         atom_dir = -atom_dir;
      }

      if (atom_state == 0) {
         atom_delay = 40;
      }



   }

   dcs[ATOM_RED_0] = atom_state;
   dcs[ATOM_RED_1] = atom_state;
   dcs[ATOM_RED_2] = atom_state;
   dcs[ATOM_RED_3] = atom_state;
   dcs[ATOM_RED_4] = atom_state;
   dcs[ATOM_RED_5] = atom_state;
}

#define BLUE_PHASE_LEN 200
#define BLINK_LEN 150
#define BLINK2_LEN 90
#define GREEN_PHASE_START (BLUE_PHASE_LEN+BLINK_LEN+BLINK2_LEN)
#define GREEN_PHASE_LEN 200
#define GREEN_BLINK_START (GREEN_PHASE_START+GREEN_PHASE_LEN)
#define GREEN_BLINK2_START (GREEN_PHASE_START+GREEN_PHASE_LEN+BLINK2_LEN)




// another wicked function from philipp
// lets the phone blink in green and blue in different patterns
void step_phone() {
   phone_count++;
   switch (phone_state) {
      case 0:
         if (phone_count < BLUE_PHASE_LEN) {
            dcs[PHONE_BLUE_0] = 63;
            dcs[PHONE_BLUE_1] = 63;
            dcs[PHONE_BLUE_2] = 63;
            dcs[PHONE_GREEN_1] = 0;
            dcs[PHONE_GREEN_0] = 0;
            dcs[PHONE_GREEN_1] = 0;
            dcs[PHONE_GREEN_2] = 0;
            dcs[PHONE_GREEN_3] = 0;
         }
         else if (phone_count < BLUE_PHASE_LEN+BLINK_LEN) {
            if (((phone_count-BLUE_PHASE_LEN)>>4 & 1) == 0) {
               dcs[PHONE_GREEN_0] = 63;
               dcs[PHONE_GREEN_1] = 63;
               dcs[PHONE_GREEN_2] = 63;
               dcs[PHONE_GREEN_3] = 63;
               dcs[PHONE_BLUE_0] = 0;
               dcs[PHONE_BLUE_1] = 0;
               dcs[PHONE_BLUE_2] = 0;
            }
            else {
               dcs[PHONE_GREEN_1] = 0;
               dcs[PHONE_GREEN_0] = 0;
               dcs[PHONE_GREEN_1] = 0;
               dcs[PHONE_GREEN_2] = 0;
               dcs[PHONE_GREEN_3] = 0;
               dcs[PHONE_BLUE_0] = 63;
               dcs[PHONE_BLUE_1] = 63;
               dcs[PHONE_BLUE_2] = 63;
            }
         }
         else if (phone_count < BLUE_PHASE_LEN+BLINK_LEN+BLINK2_LEN) {
            if (((phone_count-(BLUE_PHASE_LEN+BLINK_LEN))>>1 & 1) == 1) {
               dcs[PHONE_GREEN_0] = 63;
               dcs[PHONE_GREEN_1] = 63;
               dcs[PHONE_GREEN_2] = 63;
               dcs[PHONE_GREEN_3] = 63;
               dcs[PHONE_BLUE_0] = 0;
               dcs[PHONE_BLUE_1] = 0;
               dcs[PHONE_BLUE_2] = 0;
            }
            else {
               dcs[PHONE_GREEN_1] = 0;
               dcs[PHONE_GREEN_0] = 0;
               dcs[PHONE_GREEN_1] = 0;
               dcs[PHONE_GREEN_2] = 0;
               dcs[PHONE_GREEN_3] = 0;
               dcs[PHONE_BLUE_0] = 63;
               dcs[PHONE_BLUE_1] = 63;
               dcs[PHONE_BLUE_2] = 63;
            }
         }
         else if (phone_count < GREEN_BLINK_START) {
            dcs[PHONE_BLUE_0] = 0;
            dcs[PHONE_BLUE_1] = 0;
            dcs[PHONE_BLUE_2] = 0;
            dcs[PHONE_GREEN_0] = 63;
            dcs[PHONE_GREEN_1] = 63;
            dcs[PHONE_GREEN_2] = 63;
            dcs[PHONE_GREEN_3] = 63;
         }
         else if (phone_count < GREEN_BLINK_START+BLINK_LEN) {
            if (((phone_count-GREEN_BLINK_START)>>4 & 1) == 0) {
               dcs[PHONE_GREEN_0] = 63;
               dcs[PHONE_GREEN_1] = 63;
               dcs[PHONE_GREEN_2] = 63;
               dcs[PHONE_GREEN_3] = 63;
               dcs[PHONE_BLUE_0] = 0;
               dcs[PHONE_BLUE_1] = 0;
               dcs[PHONE_BLUE_2] = 0;
            }
            else {
               dcs[PHONE_GREEN_1] = 0;
               dcs[PHONE_GREEN_0] = 0;
               dcs[PHONE_GREEN_1] = 0;
               dcs[PHONE_GREEN_2] = 0;
               dcs[PHONE_GREEN_3] = 0;
               dcs[PHONE_BLUE_0] = 63;
               dcs[PHONE_BLUE_1] = 63;
               dcs[PHONE_BLUE_2] = 63;
            }
         }
         else if (phone_count < GREEN_BLINK_START+BLINK_LEN+BLINK2_LEN) {
            if (((phone_count-364)>>1 & 1) == 0) {
               dcs[PHONE_GREEN_0] = 63;
               dcs[PHONE_GREEN_1] = 63;
               dcs[PHONE_GREEN_2] = 63;
               dcs[PHONE_GREEN_3] = 63;
               dcs[PHONE_BLUE_0] = 0;
               dcs[PHONE_BLUE_1] = 0;
               dcs[PHONE_BLUE_2] = 0;
            }
            else {
               dcs[PHONE_GREEN_1] = 0;
               dcs[PHONE_GREEN_0] = 0;
               dcs[PHONE_GREEN_1] = 0;
               dcs[PHONE_GREEN_2] = 0;
               dcs[PHONE_GREEN_3] = 0;
               dcs[PHONE_BLUE_0] = 63;
               dcs[PHONE_BLUE_1] = 63;
               dcs[PHONE_BLUE_2] = 63;
            }
         }

         if (phone_count > GREEN_BLINK2_START+BLINK2_LEN) {
            phone_count = 0;
         }
         break;
   }

}













// this function is currently NOT in use but should be easy to implement 
// if you want to use this check out the rainbow() function
int rotate_color(int color_offset, int rotate_offset)
{
  int i;
  int beforeoffset;
  int nextoffset;

  for (i = 0; i <16; i++) {
      dcs[color_offset + i] =  0;
  }

   beforeoffset= (rotate_offset-1);
   if (beforeoffset<0){ beforeoffset=15; }

   nextoffset= (rotate_offset+1);
   if(nextoffset>15){ nextoffset=0;}


  dcs[color_offset + beforeoffset] =  10;
  dcs[color_offset + rotate_offset] =  63;
  dcs[color_offset + nextoffset+1] =  10;

 rotate_offset++;

 if(rotate_offset >15)
   rotate_offset=0;

 return rotate_offset;
}












// this function will set all leds to white and turn one channel of in a round 
//  whereami is a pointer to function_whereami  defined in the main loop
//  trough this the function knows  how often it did loop and can choose itself howmany steps it will run

int flash (int *whereami)
{
  int reverse;
  //int brightness1;
  //int brightness2;  
  
  //int inverse_x;

  //inverse_x = (rand()%2) +1;
  brightness1=0;
  brightness2=63;

  all_off();
   all_on(RED,63);
   all_on(GREEN,63);
   all_on(BLUE,63);


/*
  if (inverse_x != 1 )
  {
   brightness1=63;
   brightness2=0;

  }
  
 */
 
  


     // if you want to read or write o a poiter you have to prefix it with *
     // otherwise whereami would return its address in memory  .. probably not what you want ;)
     if((*whereami) <8)
     {

      // go from left to right in both groups
      dcs[RED + (*whereami)] =  brightness1;
      dcs[RED + (15 - (*whereami))] =  brightness1;
      dcs[BLUE + (*whereami)] =  brightness1;
      dcs[BLUE + (15 - (*whereami))] =  brightness1;
      dcs[GREEN + (*whereami)] =  brightness1;
      dcs[GREEN + (15 - (*whereami))] =  brightness1;
     }
     else
     {
     	
     // go from right to left with different on/off setting for a nice wooosh  effect 	
      reverse=-*whereami;
      dcs[RED - reverse ] =  brightness2;
      dcs[RED - (15 + reverse )] =  brightness1;
      dcs[BLUE - reverse] =  brightness2;
      dcs[BLUE - (15 + reverse )] = brightness1;
      dcs[GREEN - reverse] =  brightness2;
      dcs[GREEN - (15 + reverse )] =  brightness1;

     }

               //run 16 steps
               if(*whereami>16)
               {
                function_active=0;
               }


// just do something new every 10 steps
// this can regulate the timing of a function within the function itself
// we just set a framerate of delay_ms(10) in main
// in this case we refresh our self every ten frames thats 100ms = 10time /sec
if(!(stepper %10))
       (*whereami)++;

}















// ugly function i bet i could make this nicer if i had any interest in keeping the code clean :)
// no time to waste on that crap
// at least you get some doku 

// called from mix_color()
void set_channel(int channel, int group)
{
// uncomment for debugging only writing with prinf  slows down the pic a LOT!!!
//printf("channel %d group %d \n",channel,group);

        switch (group) {
            case 1:
             dcs[RED + channel] =  63;
             dcs[RED + (15 - channel)] =  63;
             dcs[GREEN + channel] =  0;
             dcs[GREEN + (15 - channel)] =  0;
             dcs[BLUE + channel] =  0;
             dcs[BLUE + (15 - channel)] =  0;
            break;
            case 2:
             dcs[RED + channel] =  63;
             dcs[RED + (15 - channel)] =  63;
             dcs[GREEN + channel] =  63;
             dcs[GREEN + (15 - channel)] =  63;
             dcs[BLUE + channel] =  0;
             dcs[BLUE + (15 - channel)] =  0;
            break;
            case 4:
             dcs[RED + channel] =  0;
             dcs[RED + (15 - channel)] =  0;
             dcs[GREEN + channel] =  63;
             dcs[GREEN + (15 - channel)] =  63;
             dcs[BLUE + channel] =  0;
             dcs[BLUE + (15 - channel)] =  0;
            break;
            case 8:
             dcs[RED + channel] =  0;
             dcs[GREEN + channel] =  63;
             dcs[BLUE + channel] =  63;
            break;
            case 16:
             dcs[RED + channel] =  0;
             dcs[RED + (15 - channel)] =  0;
             dcs[GREEN + channel] =  0;
             dcs[GREEN + (15 - channel)] =  0;
             dcs[BLUE + channel] =  63;
             dcs[BLUE + (15 - channel)] =  63;
            break;
            case 32:
             dcs[RED + channel] =  63;
             dcs[RED + (15 - channel)] =  63;
             dcs[GREEN + channel] =  0;
             dcs[GREEN + (15 - channel)] =  0;
             dcs[BLUE + channel] =  63;
             dcs[BLUE + (15 - channel)] =  63;
            break;
        }


}

// i couldnt find any array_shift or something similar so i built this :(
// called from mix_color()
void shift_array(int *groups)
{
 int i;
 int buff;

  buff =groups[0];
   
for (i = 0; i <7; i++) {
  groups[i]=groups[i+1];
}
  groups[7]= buff;
}


// called from rainbow()
void mix_color(int *groups)
{
 int i;

shift_array(groups);

 for (i = 0; i <8; i++) {
  set_channel(i,groups[i]);
 }

}




/*  
 rainbow effect 
 this lets the color fade from left to right 
 beautiful!
*/
void rainbow (int *whereami)
{
  int reverse;
  int i;


//slow down
if(!(stepper %3))
   for (i = 0; i <7; i++) {
     all_off();
     mix_color(groups);
   }


   if(*whereami>16)
   {
     function_active=0;
   }


// just do something new every 50 steps
if(!(stepper %50))
     (*whereami)++;

}





/* END OF FUNKY DISPLAY FUNCTIONS */








void main ()
{
	//always declare ANY variable on top of the function 
	
	
// how much delay between frames?	
   long delay=10;
   
// later defined trough a  PNG    
   int flashmode =0;


   //declares how many differents things the shield can do
   int number_of_functions=5;



   // function specific stepper
   int function_whereami=0;


  // init chip see .h file
   initTLC5940();
   clearDisplay();
   
   
  // init variables used in different places   
   init_metalab();



   // one we start we want to anounce this on the serial device
   puts("main called");
   
   // if 1 != 1  be_confused("what the fork?!")
	while (1) {


      // stepper loop + reset
      stepper++;
      if(stepper>steps)
      {
       stepper=0;
       // reset led driver when loop finishes to avoid integer overrun
       // there is some stupid bug in the header or on the chip itself..
       // whatever if you dont reset this from time to time it will produce weird outputs
       // a reset takes some miliseconds but calling it too often will slow down the PIC a lot
       initTLC5940();
       puts("reset yourself stupid chippo");
      }



      // whatever function is run make sure the phone and the atom blink and glow
      step_atom();
      step_phone();


      // this is zero on first start
      // and is set to 1 when a function finishes itself (within the function)
      if (function_active == 0)
      {
        puts("function not active making new random function");
        // choose a random diplaymode between 1 and number_of_functions (currently 5) defined a couple of lines up the code
        flashmode = (rand()%number_of_functions) +1;
        
        // reset function stepper counter
        function_whereami=0;

        // function runs now
        function_active=1;


        // testing only
        //flashmode=4;
       // printf("\n\rnew flashmode: %i\n\r", flashmode);


      }




// run the current function
         switch (flashmode) {
            case 1:
               channel_on(&function_whereami,RED);
            break;

            case 2:
               channel_on(&function_whereami,BLUE);
             break;

            case 3:
               channel_on(&function_whereami,GREEN);
            break;

            case 4:
                flash(&function_whereami);
            break;

            case 5:
                rainbow(&function_whereami);
            break;

         }




// the function itself just fills the dcs[] array refreshDisplay() will actually OUTPUT the stuff
      refreshDisplay();
  
// framerate  defined by delay     
      delay_ms(delay);
	}
}



/*
 i hope you had a pleasnt journey trough the source
 it was a wild ride and i apologise for all those bad ass hacks
 but for my excuse: i never wrote this kind of embedded C before, and i would not do it again if i had a choice :) 
 since there are a lot of weird bugs in this crap commercial compiler i used to produce the .HEX i was forced to "somehow get along"
 and finally:  it works!  
 	
  
_
  |
   0*
   ^ 	
 	
 	flo@isp.at   
 	
*/
